<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<a class="dashingAutolink" name="autolink-291"></a><a class="dashAnchor" name="//apple_ref/cpp/Package/XHXKit%3A%20%2FUsers%2Fscar1900%2FDeveloper%2FXHXKit%2FXHXKit%2FClasses%2FURLConfig%2FXHXEnvUrlLoader.m%20%E6%BA%90%E6%96%87%E4%BB%B6"></a><title>XHXKit: /Users/scar1900/Developer/XHXKit/XHXKit/Classes/URLConfig/XHXEnvUrlLoader.m 源文件</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">XHXKit
   &nbsp;<span id="projectnumber">4.10.0.12</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- 制作者 Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'搜索');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','搜索');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow" onmouseover="return searchBox.OnSearchSelectShow()" onmouseout="return searchBox.OnSearchSelectHide()" onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d522931ffa1371640980b621734a4381.html">Users</a></li><li class="navelem"><a class="el" href="dir_2f48480e0fdb0436fb8fd57a1ed5f613.html">scar1900</a></li><li class="navelem"><a class="el" href="dir_c8b33409012acfc781ba898892fd3b4c.html">Developer</a></li><li class="navelem"><a class="el" href="dir_0e1030ab80149b7e8d6dfd17946e9c40.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_c9ece41fcb3917ec137dcec44cd0055f.html">XHXKit</a></li><li class="navelem"><a class="el" href="dir_3a9521ad7c4429598be7e28fa39d3d14.html">Classes</a></li><li class="navelem"><a class="el" href="dir_6bcf088e230c952f4b5218d3b69c6b97.html">URLConfig</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">XHXEnvUrlLoader.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_x_h_x_env_url_loader_8m.html">浏览该文件的文档.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno"><a class="line" href="interface_x_h_x_env_url_loader.html#a51dfc8e28db731a4df29548c854c8f7f">    1</a></span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&nbsp;<span class="comment">//  XHXEnvUrlLoader.m</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&nbsp;<span class="comment">//  KKLOnLine</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&nbsp;<span class="comment">//  Created by Leovir on 2018/11/22.</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&nbsp;<span class="comment">//  Copyright &copy; 2018 mistong. All rights reserved.</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&nbsp;<span class="comment">//</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&nbsp; </div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&nbsp;<span class="preprocessor">#import &#34;<a class="code" href="_x_h_x_env_url_loader_8h.html">XHXEnvUrlLoader.h</a>&#34;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&nbsp;<span class="preprocessor">#import &lt;XHXRouter/XHXRouter.h&gt;</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&nbsp; </div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&nbsp;<span class="keyword">@implementation </span><a class="code" href="interface_x_h_x_env_url_loader.html">XHXEnvUrlLoader</a></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&nbsp; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&nbsp;+ (void)load</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&nbsp;{</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&nbsp;    [[XHXRouter router] addRouteUrl:@&#34;main/XHXEnvUrlLoader/envUrlDict&#34; handleBlock:^id(NSDictionary&lt;NSString *,id&gt; *parameters) {</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&nbsp;        return [<a class="code" href="interface_x_h_x_env_url_loader.html">XHXEnvUrlLoader</a> <a class="code" href="interface_x_h_x_env_url_loader.html#ac147e4f03eff938bacf8d60b7da47a21">loader</a>].envUrlDict;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&nbsp;    }];</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&nbsp;}</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&nbsp; </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&nbsp;+ (<a class="code" href="interface_x_h_x_env_url_loader.html">XHXEnvUrlLoader</a> *)<a class="code" href="interface_x_h_x_env_url_loader.html#ac147e4f03eff938bacf8d60b7da47a21">loader</a></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&nbsp;{</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&nbsp;    <span class="keyword">static</span> <a class="code" href="interface_x_h_x_env_url_loader.html">XHXEnvUrlLoader</a> *<a class="code" href="interface_x_h_x_env_url_loader.html#ac147e4f03eff938bacf8d60b7da47a21">loader</a> = nil;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&nbsp;    <span class="keyword">static</span> dispatch_once_t onceToken;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&nbsp;    dispatch_once(&amp;onceToken, ^{</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&nbsp;        <a class="code" href="interface_x_h_x_env_url_loader.html#ac147e4f03eff938bacf8d60b7da47a21">loader</a> = [[<a class="code" href="interface_x_h_x_env_url_loader.html">XHXEnvUrlLoader</a> alloc] init];</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&nbsp;    });</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&nbsp;    <span class="keywordflow">return</span> <a class="code" href="interface_x_h_x_env_url_loader.html#ac147e4f03eff938bacf8d60b7da47a21">loader</a>;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&nbsp;}</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&nbsp; </div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&nbsp;- (instancetype)init</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&nbsp;{</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&nbsp;    <span class="keyword">self</span> = [<span class="keyword">super</span> init];</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&nbsp;    <span class="keywordflow">if</span> (<span class="keyword">self</span>) {</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&nbsp;        <span class="comment">//从本地缓存取环境Url配置</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&nbsp;        NSDictionary *envDict = [<span class="keyword">self</span> loadEnvFromFile];</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&nbsp;        </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&nbsp;        <span class="keywordflow">if</span> ([<span class="keyword">self</span> envAvailable:envDict]) {</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&nbsp;            <span class="keyword">self</span>.<a class="code" href="interface_x_h_x_env_url_loader.html#a57db4eb20485f77d40485057f3c84283">envUrlDict</a> = envDict;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&nbsp;        }</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&nbsp;    }</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&nbsp;    <span class="keywordflow">return</span> <span class="keyword">self</span>;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&nbsp;}</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&nbsp; </div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&nbsp; </div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&nbsp;<span class="comment">//检查字典中的所有url是否完整</span></div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&nbsp;- (BOOL)envAvailable:(NSDictionary *)envDict</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&nbsp;{</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&nbsp;    <span class="comment">//字典是否存在&mdash;&gt;是否包含环境-&gt;每个环境中的url是否有效</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&nbsp;    <span class="keywordflow">if</span> (envDict) {</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&nbsp;        <span class="keywordflow">if</span> (envDict.allKeys.count &gt;= 1) {</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&nbsp;            NSInteger checkCount = 0;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&nbsp;            <span class="keywordflow">for</span> (NSString *key in envDict.allKeys) {</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&nbsp;                NSDictionary *env = envDict[key];</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&nbsp;                NSString *gateway = env[@&#34;Gateway&#34;];</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&nbsp;                NSString *image = env[@&#34;Image&#34;];</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&nbsp;                NSString *resourcePath = env[@&#34;ResourcePath&#34;];</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&nbsp;                NSString *configUrl = env[@&#34;ConfigUrl&#34;];</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&nbsp;                <span class="keywordflow">if</span> (gateway.length &amp;&amp; image.length &amp;&amp; resourcePath.length &amp;&amp; configUrl.length) {</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&nbsp;                    checkCount ++;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&nbsp;                }</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&nbsp;            }</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&nbsp;            <span class="keywordflow">if</span> (envDict.allKeys.count == checkCount) {</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&nbsp;                <span class="keywordflow">return</span> YES;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&nbsp;            }</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&nbsp;            <span class="keywordflow">return</span> NO;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&nbsp;        }</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&nbsp;        <span class="keywordflow">return</span> NO;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&nbsp;    }</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&nbsp;    <span class="keywordflow">return</span> NO;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&nbsp;}</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&nbsp; </div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&nbsp;- (void)save</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&nbsp;{</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&nbsp;    [<span class="keyword">self</span>.envUrlDict writeToFile:[<span class="keyword">self</span> filePath] atomically:YES];</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&nbsp;}</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&nbsp; </div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&nbsp;- (void)updateEnv:(NSString *)env key:(NSString *)key path:(NSString *)path</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&nbsp;{</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&nbsp;    <span class="keywordflow">if</span> (env.length &amp;&amp; key.length &amp;&amp; path.length) {</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&nbsp;        NSMutableDictionary *dict = [NSMutableDictionary dictionaryWithDictionary:self.envUrlDict];</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&nbsp;        NSMutableDictionary *envDict = [NSMutableDictionary dictionaryWithDictionary:dict[env]];</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&nbsp;        [envDict setObject:path forKey:key];</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&nbsp;        [dict setObject:envDict forKey:env];</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&nbsp;        <span class="keyword">self</span>.envUrlDict = dict;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&nbsp;        [<span class="keyword">self</span> save];</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&nbsp;    }</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&nbsp;}</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&nbsp; </div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&nbsp;- (NSString *)urlPathInEnv:(NSString *)env key:(NSString *)key</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&nbsp;{</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&nbsp;    <span class="keywordflow">if</span> (env.length &amp;&amp; key.length) {</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&nbsp;        <span class="keywordflow">return</span> [[<span class="keyword">self</span>.envUrlDict objectForKey:env] objectForKey:key];</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&nbsp;    }</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&nbsp;    <span class="keywordflow">return</span> nil;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&nbsp;}</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&nbsp; </div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&nbsp; </div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&nbsp; </div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&nbsp;<span class="comment">//从文件加载缓存配置</span></div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&nbsp;- (NSDictionary *)loadEnvFromFile</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&nbsp;{</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&nbsp;    <span class="keywordflow">return</span> [NSDictionary dictionaryWithContentsOfFile:[<span class="keyword">self</span> filePath]];</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&nbsp;}</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&nbsp; </div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&nbsp;- (NSString *)filePath {</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&nbsp;    NSString *path = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES).firstObject;</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&nbsp;    NSString *URLPath = [path stringByAppendingPathComponent:@&#34;EnvUrl.plist&#34;];</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&nbsp;    <span class="keywordflow">return</span> URLPath;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&nbsp;}</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&nbsp; </div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&nbsp;<span class="keyword">@end</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="ainterface_x_h_x_env_url_loader_html_ac147e4f03eff938bacf8d60b7da47a21"><div class="ttname"><a href="interface_x_h_x_env_url_loader.html#ac147e4f03eff938bacf8d60b7da47a21">+[XHXEnvUrlLoader loader]</a></div><div class="ttdeci">XHXEnvUrlLoader * loader()</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_env_url_loader_8m_source.html#l00001">XHXEnvUrlLoader.m:21</a></div></div>
<div class="ttc" id="a_x_h_x_env_url_loader_8h_html"><div class="ttname"><a href="_x_h_x_env_url_loader_8h.html">XHXEnvUrlLoader.h</a></div></div>
<div class="ttc" id="ainterface_x_h_x_env_url_loader_html"><div class="ttname"><a href="interface_x_h_x_env_url_loader.html">XHXEnvUrlLoader</a></div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_env_url_loader_8h_source.html#l00011">XHXEnvUrlLoader.h:12</a></div></div>
<div class="ttc" id="ainterface_x_h_x_env_url_loader_html_a57db4eb20485f77d40485057f3c84283"><div class="ttname"><a href="interface_x_h_x_env_url_loader.html#a57db4eb20485f77d40485057f3c84283">XHXEnvUrlLoader::envUrlDict</a></div><div class="ttdeci">NSDictionary * envUrlDict</div><div class="ttdef"><b>Definition:</b> <a href="_x_h_x_env_url_loader_8h_source.html#l00013">XHXEnvUrlLoader.h:13</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
制作者&nbsp;<a href="http://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>


</body></html>